# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::BotService::Mgmt::V2018_07_12_preview
  module Models
    #
    # The parameters to provide for the Bot.
    #
    class BotProperties

      include MsRestAzure

      # @return [String] The Name of the bot
      attr_accessor :display_name

      # @return [String] The description of the bot
      attr_accessor :description

      # @return [String] The Icon Url of the bot
      attr_accessor :icon_url

      # @return [String] The bot's endpoint
      attr_accessor :endpoint

      # @return [String] The bot's endpoint version
      attr_accessor :endpoint_version

      # @return [String] Microsoft App Id for the bot
      attr_accessor :msa_app_id

      # @return [Array<String>] Collection of channels for which the bot is
      # configured
      attr_accessor :configured_channels

      # @return [Array<String>] Collection of channels for which the bot is
      # enabled
      attr_accessor :enabled_channels

      # @return [String] The Application Insights key
      attr_accessor :developer_app_insight_key

      # @return [String] The Application Insights Api Key
      attr_accessor :developer_app_insights_api_key

      # @return [String] The Application Insights App Id
      attr_accessor :developer_app_insights_application_id

      # @return [Array<String>] Collection of LUIS App Ids
      attr_accessor :luis_app_ids

      # @return [String] The LUIS Key
      attr_accessor :luis_key


      #
      # Mapper for BotProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BotProperties',
          type: {
            name: 'Composite',
            class_name: 'BotProperties',
            model_properties: {
              display_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'description',
                type: {
                  name: 'String'
                }
              },
              icon_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'iconUrl',
                type: {
                  name: 'String'
                }
              },
              endpoint: {
                client_side_validation: true,
                required: true,
                serialized_name: 'endpoint',
                type: {
                  name: 'String'
                }
              },
              endpoint_version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'endpointVersion',
                type: {
                  name: 'String'
                }
              },
              msa_app_id: {
                client_side_validation: true,
                required: true,
                serialized_name: 'msaAppId',
                type: {
                  name: 'String'
                }
              },
              configured_channels: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'configuredChannels',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              enabled_channels: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'enabledChannels',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              developer_app_insight_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'developerAppInsightKey',
                type: {
                  name: 'String'
                }
              },
              developer_app_insights_api_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'developerAppInsightsApiKey',
                type: {
                  name: 'String'
                }
              },
              developer_app_insights_application_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'developerAppInsightsApplicationId',
                type: {
                  name: 'String'
                }
              },
              luis_app_ids: {
                client_side_validation: true,
                required: false,
                serialized_name: 'luisAppIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              luis_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'luisKey',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
